=== debian/changelog ===
gromacs (4.6.5-1build1) trusty; urgency=medium

  * No-change rebuild for libopenmpi1.3 -> libopenmpi1.6 transition.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 14 Dec 2013 22:57:15 -0500

gromacs (4.6.5-1) unstable; urgency=low

  * New upstream release.
  * rules: Override autodetection of CPU extensions on amd64 and i386; 
    force to SSE2 only, and provide new DEB_BUILD_OPTIONS=cpuopt flag to
    re-enable autodetection for local builds.  (Closes: #725013)
  * rules: Fix misplaced COPYING symlink in gromacs-data.
  * source/lintian-overrides: Add overrides for outstanding lintian bugs
    #729096 (newer policy version), #724866 (libmpich-dev not virtual).
  * patches/20_manpages.patch: Fix formatting errors in the NAME line of
    several man pages.
  * gromacs-data.doc-base: Change root to getting_started.html.  The
    shipped HTML documentation is slowly being eliminated in favor of a
    wiki on gromacs.org.

 -- Nicholas Breen <nbreen@debian.org>  Mon, 09 Dec 2013 10:40:36 -0800
