=== debian/watch ===
# See uscan(1) for format

version=3
opts=pasv,uversionmangle=s/[-_]((pre|beta)[^.]+)/~$1/ \
ftp://ftp.gromacs.org/pub/gromacs/gromacs-([\d\.betapr_-]*)\.tar\.gz
